unit untBWC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, untEngine, ExtCtrls, StdCtrls, Menus;

Const
  BWC_VS=0;
  BWC_PLAY=1;
  PutChessTime=500;

type
  TfrmBWC = class(TForm)
    pbC: TPaintBox;
    lbC: TLabel;
    MainMenu1: TMainMenu;
    mnuGame: TMenuItem;
    mnuGameNew: TMenuItem;
    mnuGameExit: TMenuItem;
    mnuGameNewVS: TMenuItem;
    mnuGameNewPlay1: TMenuItem;
    mnuGameNewPlay2: TMenuItem;
    mnuGameShowvalue: TMenuItem;
    mnuGameShowcd: TMenuItem;
    mnuGameCC: TMenuItem;
    mnuHelp: TMenuItem;
    mnuHelpAbout: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pbCPaint(Sender: TObject);
    procedure mnuGameNewVSClick(Sender: TObject);
    procedure mnuGameNewPlay1Click(Sender: TObject);
    procedure pbCMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuGameExitClick(Sender: TObject);
    procedure mnuGameNewPlay2Click(Sender: TObject);
    procedure mnuGameShowvalueClick(Sender: TObject);
    procedure mnuGameShowcdClick(Sender: TObject);
    procedure mnuGameCCClick(Sender: TObject);
    procedure mnuHelpAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure NewGame(BWCStyle:Integer);
    Procedure ChangeMessage;
    Procedure PutChess(X,Y:Integer);
    Procedure RefreshBrd;
  end;

  TChessCount=Record
                White,Black:Integer;
              End;

var
  frmBWC: TfrmBWC;
  Style:Integer;
  Player:Integer;
  Level:Integer;
  ChessCount:Array[0..64]Of TChessCount;
  ChessCounts:Integer;

implementation

uses untChessCount, untAbout;

{$R *.dfm}

Procedure TfrmBWC.RefreshBrd;
var X,Y:Integer;
Begin
  bwcDraw(pbC.Canvas,Player,mnuGameShowcd.Checked);
  If mnuGameShowvalue.Checked=False Then Exit;
  pbC.Canvas.Brush.Style:=bsClear;
  pbC.Canvas.Font.Color:=16777215;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      If Level=0 Then
        pbC.Canvas.TextOut((X-1)*50,(Y-1)*50,IntToStr(bwcGetPositionValue(Board,X,Y,Player,2)))
      Else
        pbC.Canvas.TextOut((X-1)*50,(Y-1)*50,IntToStr(bwcGetPositionValue(Board,X,Y,Player,Level)));
End;

Procedure TfrmBWC.PutChess(X,Y:Integer);
Begin
  If bwcGetEatCount(Board,(X div 50)+1,(Y div 50)+1,Player)=0 Then
  Begin
    ShowMessage('λò塣');
    Exit;
  End;
  bwcPutChess(Board,(X div 50)+1,(Y div 50)+1,Player);
  Player:=(Player+1) mod 2;
  RefreshBrd;
  ChessCount[ChessCounts].White:=bwcGetChessCount(Board,0);
  ChessCount[ChessCounts].Black:=bwcGetChessCount(Board,1);
  ChessCounts:=ChessCounts+1;
  If bwcCanPutChess(Board,Player)=False Then
  Begin
    Player:=(Player+1) mod 2;
    If bwcCanPutChess(Board,Player)=False Then
      If bwcGetChessCount(Board,0)>bwcGetChessCount(Board,1) Then
      Begin
         ChangeMessage;
        ShowMessage('׷ʤ');
        frmChessCount.ShowModal;
        Player:=0;
      End
      Else If bwcGetChessCount(Board,0)<bwcGetChessCount(Board,1) Then
      Begin
         ChangeMessage;
        ShowMessage('ڷʤ');
        frmChessCount.ShowModal;
        Player:=0;
      End
      Else
      Begin
        ChangeMessage;
        ShowMessage('塣');
        frmChessCount.ShowModal;
        Player:=0;
      End
    Else
      If Player=0 Then
        ShowMessage('ֵ׷塣')
      Else
        ShowMessage('ֵڷ塣');
  End;

  ChangeMessage;
End;

Procedure TfrmBWC.NewGame(BWCStyle:Integer);
Begin
  Style:=BWCStyle;
  bwcClearBoard;
  Player:=0;
  RefreshBrd;
  ChangeMessage;
  Randomize;
  If Style=BWC_VS Then
    Caption:='ڰ[˫˶ս]'
  Else
    Caption:='ڰ[˻]';
  ChessCounts:=5;
  ChessCount[0].White:=0;
  ChessCount[0].Black:=0;
  ChessCount[1].White:=1;
  ChessCount[1].Black:=0;
  ChessCount[2].White:=1;
  ChessCount[2].Black:=1;
  ChessCount[3].White:=2;
  ChessCount[3].Black:=1;
  ChessCount[4].White:=2;
  ChessCount[4].Black:=2;
End;

Procedure TfrmBWC.ChangeMessage;
var R:String;
Begin
  R:=''+IntToStr(bwcGetChessCount(Board,0))+' ';
  R:=R+''+IntToStr(bwcGetChessCount(Board,1))+' ';
  If Player=0 Then
    R:=R+'ִ'
  Else
    R:=R+'ִ';
  lbC.Caption:=R;
End;

procedure TfrmBWC.FormCreate(Sender: TObject);
begin
  frmBWC.Left:=(Screen.Width-frmBWC.Width) div 2;
  frmBWC.Top:=(Screen.Height-frmBWC.Height) div 2;
  bwcInit;
  bwcClearBoard;
  NewGame(BWC_VS);
end;

procedure TfrmBWC.FormDestroy(Sender: TObject);
begin
  bwcFree;
end;

procedure TfrmBWC.pbCPaint(Sender: TObject);
begin
  RefreshBrd;
end;

procedure TfrmBWC.mnuGameNewVSClick(Sender: TObject);
begin
  Level:=0;
  NewGame(BWC_VS);
  (Sender As TMenuItem).Checked:=True;
end;

procedure TfrmBWC.mnuGameNewPlay1Click(Sender: TObject);
begin
  Level:=1;
  NewGame(BwC_PLAY);
  (Sender As TMenuItem).Checked:=True;
end;

procedure TfrmBWC.pbCMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var R:Integer;
begin
  If Style=BWC_VS Then
    PutChess(X,Y)
  Else
  Begin
    If Player=0 Then
      PutChess(X,Y);
    If Player=1 Then
    Begin
      Repeat
        Sleep(PutChessTime);
        R:=bwcGetBestPosition(Level);
        PutChess((R mod 10)*50-1,(R div 10)*50-1);
      Until Player=0;  
    End;
  End;
end;

procedure TfrmBWC.mnuGameExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmBWC.mnuGameNewPlay2Click(Sender: TObject);
begin
  Level:=2;
  NewGame(BwC_PLAY);
  (Sender As TMenuItem).Checked:=True;
end;

procedure TfrmBWC.mnuGameShowvalueClick(Sender: TObject);
begin
  mnuGameShowvalue.Checked:=Not mnuGameShowvalue.Checked;
  RefreshBrd;
end;

procedure TfrmBWC.mnuGameShowcdClick(Sender: TObject);
begin
  mnuGameShowcd.Checked:=Not mnuGameShowcd.Checked;
  RefreshBrd;
end;

procedure TfrmBWC.mnuGameCCClick(Sender: TObject);
begin
  frmChessCount.ShowModal;
end;

procedure TfrmBWC.mnuHelpAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

end.
