unit untEngine;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

Const Paths:Array[0..3]Of String=(
            'White.bmp','Black.bmp','Back.bmp','Position.bmp');
      BWCDirection:Array[0..7]Of Array[0..1]Of Integer=(
                   (0,-1),(1,-1),(1,0),(1,1),(0,1),(-1,1),(-1,0),(-1,-1));

Type
  TBoard=Array[0..9]Of Array[0..9]Of Integer;

var Board:TBoard;
    Pic:Array[0..3]Of TBitmap;
    BmpBrd:TBitmap;

Procedure bwcInit;
Procedure bwcFree;
Procedure bwcClearBoard;
Procedure bwcDraw(Canvas:TCanvas;Color:Integer;ShowCanDown:Boolean);
Function bwcGetEatCount(Brd:TBoard;X,Y,Color:Integer):Integer;
Procedure bwcPutChess(var Brd:TBoard;X,Y,Color:Integer);
Function bwcCanPutChess(Brd:TBoard;Color:Integer):Boolean;
Function bwcGetChessCount(Brd:TBoard;Color:Integer):Integer;
///////////////////////////////////////////////////////////////////////////
Procedure bwcCopyBoard(var Dst:TBoard;Src:TBoard);
Function bwcGetPositionValue1(Brd:TBoard;X,Y,Color:Integer):Integer;
Function bwcGetPositionValue2(Brd:TBoard;bX,bY,Color:Integer):Integer;
Function bwcGetPositionValue(Brd:TBoard;X,Y,Color:Integer;Level:Integer):Integer;
Function bwcGetBestPosition(Level:Integer):Integer;

implementation

Procedure bwcInit;
var I:Integer;
Begin
  For I:=0 TO 3 Do
  Begin
    Pic[I]:=TBitmap.Create;
    Pic[I].LoadFromFile(ExtractFilePath(ParamStr(0))+Paths[I]);
  End;
  BmpBrd:=TBitmap.Create;
  BmpBrd.Width:=400;
  BmpBrd.Height:=400;
End;

Procedure bwcFree;
var I:Integer;
Begin
  For I:=0 To 3 Do
    Pic[I].Free;
  BmpBrd.Free;
End;

Procedure bwcClearBoard;
var X,Y:Integer;
Begin
  For X:=0 To 9 Do
    For Y:=0 To 9 Do
      Board[X,Y]:=2;
  Board[4,4]:=1;
  Board[4,5]:=0;
  Board[5,4]:=0;
  Board[5,5]:=1;
End;

Procedure bwcDraw(Canvas:TCanvas;Color:Integer;ShowCanDown:Boolean);
var X,Y:Integer;
Begin
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
    Begin
      If Board[X,Y]=2 Then
        If ShowCanDown=True Then
          If bwcGetEatCount(Board,X,Y,Color)>0 Then
            BmpBrd.Canvas.Draw((X-1)*50,(Y-1)*50,Pic[3])
          Else
            BmpBrd.Canvas.Draw((X-1)*50,(Y-1)*50,Pic[2])
        Else
          BmpBrd.Canvas.Draw((X-1)*50,(Y-1)*50,Pic[2])
      Else
        BmpBrd.Canvas.Draw((X-1)*50,(Y-1)*50,Pic[Board[X,Y]]);
    End;
  Canvas.Draw(0,0,BmpBrd);  
End;

Function bwcGetEatCount(Brd:TBoard;X,Y,Color:Integer):Integer;
var Direction,cX,cY,EatCount,Distance:Integer;
Begin
  If Brd[X,Y]<>2 Then
  Begin
    bwcGetEatCount:=0;
    Exit;
  End;
  EatCount:=0;
  For Direction:=0 To 7 Do
  Begin
    cX:=X;
    cY:=Y;
    Distance:=0;
    Repeat
      cX:=cX+BWCDirection[Direction,0];
      cY:=cY+BWCDirection[Direction,1];
      Distance:=Distance+1;
      If Brd[cX,cY]=2 Then
        Break;
      If Brd[cX,cY]=Color Then
      Begin
        EatCount:=EatCount+Distance-1;
        Break;
      End;
    Until((cX=0)Or(cX=9)Or(cY=0)Or(cY=9));
  End;
  bwcGetEatCount:=EatCount;
End;

Procedure bwcPutChess(var Brd:TBoard;X,Y,Color:Integer);
var Direction,cX,cY,pX,pY:Integer;
Begin
  For Direction:=0 To 7 Do
  Begin
    cX:=X;
    cY:=Y;
    Repeat
      cX:=cX+BWCDirection[Direction,0];
      cY:=cY+BWCDirection[Direction,1];
      If Brd[cX,cY]=2 Then
        Break;
      If Brd[cX,cY]=Color Then
      Begin
        pX:=X;
        pY:=Y;
        Repeat
          pX:=pX+BWCDirection[Direction,0];
          pY:=pY+BWCDirection[Direction,1];
          Brd[pX,pY]:=Color;
        Until (pX=cX)And(pY=cY);
        Break;
      End;
    Until((cX=0)Or(cX=9)Or(cY=0)Or(cY=9));
  End;
  Brd[X,Y]:=Color;
End;

Function bwcCanPutChess(Brd:TBoard;Color:Integer):Boolean;
var EatCount,X,Y:Integer;
Begin
  EatCount:=0;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      EatCount:=EatCount+bwcGetEatCount(Brd,X,Y,Color);
  If EatCount=0 Then
    bwcCanPutChess:=False
  Else
    bwcCanPutChess:=True;  
End;

Function bwcGetChessCount(Brd:TBoard;Color:Integer):Integer;
var X,Y,R:Integer;
Begin
  R:=0;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      If Brd[X,Y]=Color Then
        R:=R+1;
  bwcGetChessCount:=R;
End;

////////////////////////////////////////////////////////////////////

Procedure bwcCopyBoard(var Dst:TBoard;Src:TBoard);
var X,Y:Integer;
Begin
  For X:=0 To 9 Do
    For Y:=0 To 9 Do
      Dst[X,Y]:=Src[X,Y];
End;

Function bwcGetPositionValue1(Brd:TBoard;X,Y,Color:Integer):Integer;
var R:Integer;
Begin
  R:=bwcGetEatCount(Brd,X,Y,Color);
  bwcGetPositionValue1:=R;
End;

Function bwcGetPositionValue2(Brd:TBoard;bX,bY,Color:Integer):Integer;
var R,R2,X,Y,AddValue,Color2:Integer;
    TempBrd,TempBrd2:TBoard;
    AngleValue:Array[0..1]Of Array[0..1]Of Integer;
Begin
  bwcCopyBoard(TempBrd,Board);
  R:=0;
  AddValue:=0;
  If bwcGetEatCount(TempBrd,bX,bY,Color)>0 Then
  Begin

    AddValue:=200;

    For X:=0 To 1 Do
      For Y:=0 To 1 Do
        AngleValue[X,Y]:=bwcGetEatCount(Board,X*7+1,Y*7+1,Color);
    If((AngleValue[0,0]>0)Or(AngleValue[0,1]>0)Or(AngleValue[1,0]>0)Or(AngleValue[1,1]>0)) Then
      AddValue:=400;
    
    bwcPutChess(TempBrd,bX,bY,Color);
    For X:=0 To 1 Do
      For Y:=0 To 1 Do
        AngleValue[X,Y]:=bwcGetEatCount(TempBrd,X*7+1,Y*7+1,Color);
    If((AngleValue[0,0]>0)Or(AngleValue[0,1]>0)Or(AngleValue[1,0]>0)Or(AngleValue[1,1]>0)) Then
      AddValue:=300;

    Color2:=(Color+1)mod 2;
    For X:=0 To 1 Do
      For Y:=0 To 1 Do
        AngleValue[X,Y]:=bwcGetEatCount(TempBrd,X*7+1,Y*7+1,Color2);
    If((AngleValue[0,0]>0)Or(AngleValue[1,0]>0)Or(AngleValue[1,0]>0)Or(AngleValue[1,1]>0)) Then
      AddValue:=100;

    R:=10000;

    For X:=1 To 8 Do
      For Y:=1 To 8 Do
      Begin
        bwcCopyBoard(TempBrd2,TempBrd);
        If bwcGetEatCount(TempBrd2,X,Y,Color2)>0 Then
          bwcPutChess(TempBrd2,X,Y,Color2);
        R2:=bwcGetChessCount(TempBrd2,Color)-bwcGetChessCount(TempBrd2,Color2);
        If R2<R Then
          R:=R2;
      End;
    If R=10000 Then
    Begin
      bwcGetPositionValue2:=0;
      Exit;
    End;
  End;
  bwcGetPositionValue2:=R+AddValue;
End;

Function bwcGetPositionValue(Brd:TBoard;X,Y,Color:Integer;Level:Integer):Integer;
var R:Integer;
Begin
  Case Level Of
    1:
    Begin
      R:=bwcGetPositionValue1(Brd,X,Y,Color);
    End;
    2:
    Begin
      R:=bwcGetPositionValue2(Brd,X,Y,Color);
    End;
  End;
  bwcGetPositionValue:=R;
End;

Function bwcGetBestPosition(Level:Integer):Integer;
var Values:Array[1..8]Of Array[1..8]Of Integer;
    X,Y,I:Integer;
    BestValue,BestCount:Integer;
    BestPosition:Array Of TPoint;
Begin
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      Values[X,Y]:=bwcGetPositionValue(Board,X,Y,1,Level);
  BestValue:=0;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      If Values[X,Y]>BestValue Then
        BestValue:=Values[X,Y];
  BestCount:=0;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      If Values[X,Y]=BestValue Then
        BestCount:=BestCount+1;
  SetLength(BestPosition,BestCount);
  BestCount:=0;
  For X:=1 To 8 Do
    For Y:=1 To 8 Do
      If Values[X,Y]=BestValue Then
      Begin
        BestPosition[BestCount].X:=X;
        BestPosition[BestCount].Y:=Y;
        BestCount:=BestCount+1;
      End;
  I:=Random(BestCount);
  If I=BestCount THen
    I:=I-1;
  bwcGetBestPosition:=BestPosition[I].X+BestPosition[I].Y*10;
End;

end.
